#ifndef UNDECLARED_H
#define UNDECLARED_H

#pragma once

#include "stdafx.h"

// bits we need that aren't declared/defined in the headers
__if_not_exists(ObOpenObjectByName)
{
	EXTERN_C
	DECLSPEC_IMPORT
	NTSTATUS
	NTAPI
	ObOpenObjectByName(POBJECT_ATTRIBUTES, POBJECT_TYPE, KPROCESSOR_MODE, PACCESS_STATE, ACCESS_MASK, PVOID ParseContext, PHANDLE);
}

__if_not_exists(ZwQueryDirectoryObject)
{
	EXTERN_C
	DECLSPEC_IMPORT
	NTSTATUS
	NTAPI
	ZwQueryDirectoryObject(
		HANDLE DirectoryHandle,
		PVOID Buffer,
		ULONG Length,
		BOOLEAN ReturnSingleEntry,
		BOOLEAN RestartScan,
		PULONG Context,
		PULONG ReturnLength
	);
}

__if_not_exists(OBJECT_DIRECTORY_INFORMATION)
{
	typedef struct _OBJECT_DIRECTORY_INFORMATION 
	{
		UNICODE_STRING Name;
		UNICODE_STRING TypeName;
	} OBJECT_DIRECTORY_INFORMATION, *POBJECT_DIRECTORY_INFORMATION;
}

__if_not_exists(SYSTEM_PROCESS_INFORMATION)
{
	// this isn't the full structure, but it's all we need
	typedef struct _SYSTEM_PROCESS_INFORMATION 
	{
		ULONG NextEntryOffset;
		UCHAR Reserved1[52];
		PVOID Reserved2[3];
		HANDLE UniqueProcessId;
	} SYSTEM_PROCESS_INFORMATION;
}

// we use the ex version rather than the original
// as that returns 0 on failure, which is usually a valid session id
// the ex version returns -1 on failure
__if_not_exists(PsGetProcessSessionIdEx)
{
	EXTERN_C
	DECLSPEC_IMPORT
	ULONG
	NTAPI
	PsGetProcessSessionIdEx(PEPROCESS);
}

__if_not_exists(SystemProcessInformation)
{
	static const ULONG SystemProcessInformation = 5;
}

__if_not_exists(ZwQuerySystemInformation)
{
	EXTERN_C
	DECLSPEC_IMPORT
	NTSTATUS
	NTAPI
	ZwQuerySystemInformation(ULONG, PVOID, ULONG, PULONG);
}

__if_not_exists(RtlImageNtHeader)
{
	EXTERN_C DECLSPEC_IMPORT PIMAGE_NT_HEADERS NTAPI RtlImageNtHeader(PVOID pBase);
}

#endif
